/*
update.c
*/

// Ez更新
void updateEz(int Nx, int Ny, int Labc, float **Ez, float **Hx, float **Hy, float *dXn, float *dYn, float **C1Ez, float **C2Ez)
{
	const int i0 = (Labc == 0) ? 1 : 0;
	const int i1 = (Labc == 0) ? Nx : Nx + 1;
	const int j0 = (Labc == 0) ? 1 : 0;
	const int j1 = (Labc == 0) ? Ny : Ny + 1;

	for (int i = i0; i < i1; i++) {
	for (int j = j0; j < j1; j++) {
		const int i_ = i + Labc;
		const int j_ = j + Labc;
		Ez[i_][j_]
			= C1Ez[i][j] * Ez[i_][j_]
			+ C2Ez[i][j] * (dXn[i] * (Hy[i_    ][j_    ]
			                        - Hy[i_ - 1][j_    ])
			              - dYn[j] * (Hx[i_    ][j_    ]
			                        - Hx[i_    ][j_ - 1]));
	}
	}
}


// Hx更新
void updateHx(int Nx, int Ny, int Labc, float **Ez, float **Hx, float *dYc)
{
	for (int i = 0; i < Nx + 1; i++) {
	for (int j = 0; j < Ny + 0; j++) {
		const int i_ = i + Labc;
		const int j_ = j + Labc;
		Hx[i_][j_] =
		Hx[i_][j_] -
			dYc[j] * (Ez[i_    ][j_ + 1]
			        - Ez[i_    ][j_    ]);
	}
	}
}


// Hy更新
void updateHy(int Nx, int Ny, int Labc, float **Ez, float **Hy, float *dXc)
{
	for (int i = 0; i < Nx + 0; i++) {
	for (int j = 0; j < Ny + 1; j++) {
		const int i_ = i + Labc;
		const int j_ = j + Labc;
		Hy[i_][j_] =
		Hy[i_][j_] +
			dXc[i] * (Ez[i_ + 1][j_    ]
			        - Ez[i_    ][j_    ]);
	}
	}
}
