/*
plot3d.c
fdtd3d
3D図形出力, debug用
*/

#include <stdio.h>
#include <string.h>

#include "../fdtd2d/ev.h"

// 計算領域, 誘電体形状, 送受信点
void plot3d_g(int ndata, int Nx, int Ny, int Nz, int Lz,
	int nrect, int **rect, int NTx, int **Tx, const char fn[])
{
	char str[BUFSIZ];
	const float dm = 0.4f;

	// 開始
	ev3d_init();

	// 1データ=1ページ
	for (int idata = 0; idata < ndata; idata++) {
		// 改ページ
		ev3d_newPage();

		// 計算領域
		ev3d_setColor(100, 100, 100);
		ev3d_drawBox(0, 0, 0, Nx, Ny, Nz);
		ev3d_drawRectangle('Z', Lz, 0, 0, Nx, Ny);

		// 誘電体
		ev3d_setColor(0, 0, 255);
		for (int irect = 0; irect < nrect; irect++) {
			int *p = &rect[idata][6 * irect];
			ev3d_drawBox(p[0], p[1], p[2], p[3], p[4], p[5]);
		}

		// 送信点
		ev3d_setColor(255, 0, 0);
		for (int itx = 0; itx < NTx; itx++) {
			const int i = Tx[itx][0];
			const int j = Tx[itx][1];
			const int k = Tx[itx][2];
			ev3d_drawBox(i - dm, j - dm, k - dm, i + dm, j + dm, k + dm);
		}

		// タイトル
		sprintf(str, "Nx=%d Ny=%d Nz=%d Lz=%d Tx=%d rect=%d", Nx, Ny, Nz, Lz, NTx, nrect);
		ev3d_drawTitle(str);
	}

	// 出力
	ev3d_file(1, fn, 0);
	ev3d_output();
}
